.TH pemrc 5 "October 1994"  "7.0" "TIS/PEM"
.SH NAME
pemrc \- tailor file for TIS/PEM
.SH SYNOPSIS
.SH DESCRIPTION
The 
.B .pemrc
file allows you to tailor TIS/PEM to your personal liking.  The 
.B .pemrc
file consists of colon-separated tag/value pairs.  Tags are
case-insensitive while the case sensitivity of their values is
context-specific.  Following are the tailorable values and their
defaults:
.PP
.B database:.pemdb
.br
The name of the file containing the TIS/PEM database.  If it does not
contain a rooted pathname, the value of
.B directory
(below) is prepended.
.PP
.B directory:
.br
The rooted name of the directory that should be prepended to 
.B database
if it is not rooted.  The default value of nothing translates to the
contents of the 
.B $HOME
environment variable.
.PP
.B moreproc:more
.br
Default pager.
.PP
.B pwdir:/tmp
.br
Directory in which to place login state files.
.PP
.B randproc:prandom.sh
.br
Name of program used to produce unpredictable output to seed the
pseudorandom number generator when generating key pairs.  Do not
change this without due consideration.
.PP
.B tmpdir:/tmp
.br
Rooted name of directory in which to put temporary files.
.PP
.B my-alias:me
.br
Alias that identifies user records as yours.  Used when decrypting
PEM messages to determine if you are a recipient.
.PP
.B sig-alias:sig-user
.br
Alias that identifies the user record to use when creating signatures.
.PP
.B encrypt-alias:me
.br
Encrypt for user records with designated alias as well as those specified
on the command line if 
.B metoo
(below) is
.B yes.
.PP
.B metoo:yes
.br
Determines whether or not the user records with the alias associated with
.B enrypt-alias
are included as recipients in addition to any provided on the command line.
.PP
.B show-key:no
.br
Show the value of the data encryption key (DEK) when decrypting messages.
.PP
.B show-recips:no
.br
Show the list of recipients for encrypted messages.
.PP
The following are the various tailorable cryptographic values:
.PP
.B dek-alg:DES_CBC
.br
.B hash-alg:MD5
.br
.B key-alg:RSA_PUBF4
.br
.B key-len:512
.br
.B mic-alg:MD5
.br
.B sig-alg:MD2_RSA
.PP
The following are the various tailorable time periods, all of which 
are measured in seconds by default, but can have the letters 
.B h, d, m, 
or
.B y
appended to signify hours, days, months, and years, respectively:
.br
.B cert-period:2y
.br
.B crl-period:14d
.PP
All of the tailorable values can also be included on the command line
of TIS/PEM commands, overiding the coded defaults and values in the 
.B .pemrc 
file, by separating the tags and values with spaces. 
.SH FILES
$HOME/.pemrc
.SH SEE ALSO
pem(1)
.SH BUGS
